#include "stdafx.h"
extern "C"
{
   #include "RiceDecompression.h"
}
#include <windows.h>
#include <stdio.h>
#include "ftd2xx.h"
#include <conio.h> 
#using <mscorlib.dll>
#using <system.dll>
using namespace System;
using namespace System::IO;

//FILE *fp_debug=fopen("debug.txt","w");
//fp_debug=fopen("debug.txt","w");
//FILE *fp_test=fopen("mpdu.dat","wb");
//FILE *fp_data=fopen("cvcdu.dat","wb");
//FILE *fp_in=fopen("raw.dat","rb");

struct frame_struct {
	unsigned char cvcdu_hdr[6];
	unsigned char mpdu_hdr[2];
	unsigned char mpdu_data[884];
	unsigned char rs[128];
	unsigned char sync[4];
}frame;

unsigned char vc_id;
unsigned int cvcdu_counter;
unsigned int first_hdr_ptr;
unsigned int cvcdu_index;
unsigned int mpdu_index;
unsigned int mpdu_remaining;

struct cp_pdu {
	//CP_PDU Header Info
	unsigned int cp_pdu_phdr;
	unsigned int cp_pdu_pdata;
	unsigned char cp_pdu_hdr[6];
	unsigned char cp_pdu_data[8190];	//***new
	unsigned char cp_pdu_crc[2];		//***new
	unsigned int apid;
	unsigned char seq_flag;
	unsigned int counter;
	unsigned int len;
	//S_PDU Primary Header Record Info - Type 0 Record
	unsigned int s_pdu_hdr_len;
	//S_PDU Image Structure Record Info - Type 1 Record
	unsigned char bits_per_pixel;
	unsigned int num_columns;
	unsigned int num_lines;
	unsigned char compress;
	//S_PDU Rice Compression Record Info - Type 131 Record
    unsigned int flags;
	unsigned char pixels_per_block;
	unsigned char scan_lines_per_packet;
	//S_PDU Annotation Record Info - Type 4 Record
	FILE *fp;
	char filename[65];
};

	unsigned char reedout[30000];		//reed solomon uncompressed data arrray
	struct cp_pdu vcid[63];				//array of structures for CP_PDU data

	FT_HANDLE ftHandle;
	FT_STATUS ftStatus;
	DWORD BytesRecQueue;


int OpenUSB(void)
{
	DWORD iNumDevs;
	DWORD devIndex = 0;
	char SerialNumber[64],Description[256];

	ftStatus = FT_ListDevices(&iNumDevs,NULL,FT_LIST_NUMBER_ONLY);
	if(ftStatus == FT_OK){
		if (iNumDevs == 1) {
			printf("\tThere is %ld device attached\n", iNumDevs);
		}
		else {
			printf("\tThere are %ld devices attached\n", iNumDevs);
		}
		ftStatus = FT_ListDevices((PVOID)devIndex,SerialNumber,FT_LIST_BY_INDEX|FT_OPEN_BY_SERIAL_NUMBER);
	  	if(ftStatus == FT_OK){ 
			printf("\tSerial Number of device 0: %s\n", SerialNumber);
			ftStatus = FT_ListDevices((PVOID)devIndex,Description,FT_LIST_BY_INDEX|FT_OPEN_BY_DESCRIPTION);	
			if(ftStatus == FT_OK) {
				printf("\tDescription of device 0: %s\n", Description);
				ftStatus = FT_OpenEx(Description, 2, &ftHandle);
				if(ftStatus == FT_OK) {
					printf("\tDevice 0 opened.\n");
					return 1;
				}
				else {
					printf("\tFailed to open device 0.\n");
					return 0;
				}
			}
			else {
				printf("Obtaining description of device 0 failed\n");
				return 0;
			}
		}
		else {
			printf("Obtaining serial number of device 0 failed\n");
			return 0;
		}
	}
	else {
		printf("List number of devices failed\n");
		return 0;
	}
}
int Sync(int mode)
{
	char InvDataClrSync[1]={'0'};
	char DataClrSync[1]={'1'};
	char InvDataSync[1]={'2'};
	char DataSync[1]={'3'};
	DWORD BytesSent;

	if (mode=1) { //1=search for sync, 0=disable sync
		ftStatus = FT_Write(ftHandle,InvDataClrSync,1,&BytesSent);
		Sleep(100);
		ftStatus = FT_ResetDevice(ftHandle);
		ftStatus = FT_Purge(ftHandle, FT_PURGE_RX | FT_PURGE_TX);
		ftStatus = FT_Write(ftHandle,InvDataSync,1,&BytesSent);
		Sleep(500);
		ftStatus = FT_GetQueueStatus(ftHandle, &BytesRecQueue);
		if (BytesRecQueue<100) {
			ftStatus = FT_Write(ftHandle,DataClrSync,1,&BytesSent);
			Sleep(100);
			ftStatus = FT_Write(ftHandle,DataSync,1,&BytesSent);
			Sleep(500);
			ftStatus = FT_GetQueueStatus(ftHandle, &BytesRecQueue);
			if (BytesRecQueue<100) {
				printf("Failed to sync, press any key to exit.\n");
				getchar();
				return 0;
			}
			else {
				ftStatus = FT_Write(ftHandle,DataClrSync,1,&BytesSent);
				Sleep(100);
				ftStatus = FT_ResetDevice(ftHandle);
				ftStatus = FT_Purge(ftHandle, FT_PURGE_RX | FT_PURGE_TX);
				ftStatus = FT_Write(ftHandle,DataSync,1,&BytesSent);
				return 1;
			}
		}
		else {
			ftStatus = FT_Write(ftHandle,DataClrSync,1,&BytesSent);
			Sleep(100);
			ftStatus = FT_ResetDevice(ftHandle);
			ftStatus = FT_Purge(ftHandle, FT_PURGE_RX | FT_PURGE_TX);
			ftStatus = FT_Write(ftHandle,InvDataSync,1,&BytesSent);
			return 1;
		}
	}
	else{
		ftStatus = FT_Write(ftHandle,InvDataClrSync,1,&BytesSent);
		return 1;
	}
}

void Decode_VCDU(void)
{
	cvcdu_index=0;
	cvcdu_index++;
	vc_id=frame.cvcdu_hdr[cvcdu_index] & 0x3f;
	cvcdu_index++;
	cvcdu_counter=((unsigned int)frame.cvcdu_hdr[cvcdu_index] << 16);
	cvcdu_index++;
	cvcdu_counter=cvcdu_counter | ((unsigned int)frame.cvcdu_hdr[cvcdu_index] << 8);
	cvcdu_index++;
	cvcdu_counter=cvcdu_counter | ((unsigned int)frame.cvcdu_hdr[cvcdu_index]);
//fprintf(fp_debug,"vcid=%d counter=%d\n",vc_id,cvcdu_counter);
	return;
}

void Decode_MPDU(void)
{
	mpdu_index = 0;
	first_hdr_ptr=(unsigned int)(frame.mpdu_hdr[mpdu_index] & 0x07)<<8;
	mpdu_index++;
	first_hdr_ptr=first_hdr_ptr | (unsigned int)(frame.mpdu_hdr[mpdu_index]);
//fprintf(fp_debug,"     1st header pointer=%u\n",first_hdr_ptr);
	mpdu_index = 0;
	return;
}

void Initialize(void)
{
	for (unsigned char x=0; x<63; x++) {
		vcid[x].cp_pdu_phdr = 0;
		vcid[x].cp_pdu_pdata = 0;
		strcpy(vcid[x].filename, "");
		vcid[x].compress = 0;
	}
	return;
}

void Decode_CP_PDU(void)
{
	vcid[vc_id].cp_pdu_phdr=0;
	vcid[vc_id].apid = ((unsigned int)(vcid[vc_id].cp_pdu_hdr[vcid[vc_id].cp_pdu_phdr++] & 0x07)) << 8;
	vcid[vc_id].apid = vcid[vc_id].apid | ((unsigned int)(vcid[vc_id].cp_pdu_hdr[vcid[vc_id].cp_pdu_phdr++]));
	vcid[vc_id].seq_flag = (vcid[vc_id].cp_pdu_hdr[vcid[vc_id].cp_pdu_phdr] & 0xc0) >> 6;
	vcid[vc_id].counter = ((unsigned int)(vcid[vc_id].cp_pdu_hdr[vcid[vc_id].cp_pdu_phdr++] & 0x3f)) << 8;
	vcid[vc_id].counter = vcid[vc_id].counter | ((unsigned int)(vcid[vc_id].cp_pdu_hdr[vcid[vc_id].cp_pdu_phdr++]));
	vcid[vc_id].len = ((unsigned int)(vcid[vc_id].cp_pdu_hdr[vcid[vc_id].cp_pdu_phdr++])) << 8;
	vcid[vc_id].len = vcid[vc_id].len | (unsigned int)(vcid[vc_id].cp_pdu_hdr[vcid[vc_id].cp_pdu_phdr++]);
//fprintf(fp_debug,"          apid=%u counter=%u seq flag=%d\n",vcid[vc_id].apid, vcid[vc_id].counter, vcid[vc_id].seq_flag);
	return;
}

void Decode_S_PDU(void)
{
	vcid[vc_id].cp_pdu_pdata=10;	//1st byte of the S_PDU Primary Header, right after the Transport File Header
	vcid[vc_id].cp_pdu_pdata=vcid[vc_id].cp_pdu_pdata + 4;		//Total Header Length
	vcid[vc_id].s_pdu_hdr_len = ((unsigned int)(vcid[vc_id].cp_pdu_data[vcid[vc_id].cp_pdu_pdata++]))<<24;
	vcid[vc_id].s_pdu_hdr_len = vcid[vc_id].s_pdu_hdr_len | ((unsigned int)(vcid[vc_id].cp_pdu_data[vcid[vc_id].cp_pdu_pdata++]))<<16;
	vcid[vc_id].s_pdu_hdr_len = vcid[vc_id].s_pdu_hdr_len | ((unsigned int)(vcid[vc_id].cp_pdu_data[vcid[vc_id].cp_pdu_pdata++]))<<8;
	vcid[vc_id].s_pdu_hdr_len = vcid[vc_id].s_pdu_hdr_len | (unsigned int)(vcid[vc_id].cp_pdu_data[vcid[vc_id].cp_pdu_pdata++]);
	vcid[vc_id].cp_pdu_pdata=vcid[vc_id].cp_pdu_pdata + 8;				//skip data field length for now
	unsigned int end_of_all_headers = vcid[vc_id].s_pdu_hdr_len + 10;	//total header length + 10 bytes from Transport Hdr
	unsigned char record_type;
	unsigned int record_length; 
	unsigned int fn = 0;
	for (unsigned int x=10 ; x<end_of_all_headers; x++){
		record_type = vcid[vc_id].cp_pdu_data[x++];
		record_length =  ((unsigned int)(vcid[vc_id].cp_pdu_data[x++]))<<8;
		record_length = record_length | (unsigned int)(vcid[vc_id].cp_pdu_data[x++]);
		switch(record_type)
		{
			case 1:
				vcid[vc_id].bits_per_pixel=vcid[vc_id].cp_pdu_data[x++];
				vcid[vc_id].num_columns =  ((unsigned int)(vcid[vc_id].cp_pdu_data[x++]))<<8;
				vcid[vc_id].num_columns = vcid[vc_id].num_columns | (unsigned int)(vcid[vc_id].cp_pdu_data[x++]);
				vcid[vc_id].num_lines =  ((unsigned int)(vcid[vc_id].cp_pdu_data[x++]))<<8;
				vcid[vc_id].num_lines = vcid[vc_id].num_columns | (unsigned int)(vcid[vc_id].cp_pdu_data[x++]);
				vcid[vc_id].compress = vcid[vc_id].cp_pdu_data[x];
				break;

			case 4:									//annotation record with filename info
				for (unsigned int f=3; f<record_length; f++) {	//offset 3 to skip record type and length info
					vcid[vc_id].filename[fn++] = vcid[vc_id].cp_pdu_data[x++];
				}
				vcid[vc_id].filename[fn] = '\0';	//null character to complete string
				x--;								//don't increment after last byte, main loop does that for us, but here is a local loop
				break;

			case 131:								//reed solomon record
				vcid[vc_id].flags =  ((unsigned int)(vcid[vc_id].cp_pdu_data[x++]))<<8;
				vcid[vc_id].flags = vcid[vc_id].flags | (unsigned int)(vcid[vc_id].cp_pdu_data[x++]);
				vcid[vc_id].pixels_per_block = vcid[vc_id].cp_pdu_data[x++];
				vcid[vc_id].scan_lines_per_packet = vcid[vc_id].cp_pdu_data[x];
				break;

			default:								//skip all other records for now
				x=x+(record_length-4);				//subtract record type and record length bytes = 4
				break;
		}
	}
//fprintf(fp_debug,"          bpp=%d pixels=%u lines=%u compress=%d\n",vcid[vc_id].bits_per_pixel, vcid[vc_id].num_columns, vcid[vc_id].num_lines, vcid[vc_id].compress );
//fprintf(fp_debug,"          flags=%u ppb=%u slpp=%d \n", vcid[vc_id].flags, vcid[vc_id].pixels_per_block, vcid[vc_id].scan_lines_per_packet);
	return;
}

void Process_CP_PDU(void)
{
	if (vcid[vc_id].apid != 2047) {
		switch(vcid[vc_id].seq_flag)
		{
			case 0:
				if (vcid[vc_id].filename[0] != '\0'){
					if (vcid[vc_id].compress == 1){		//decompression required
					//	CRiceDecompression riceDecomp(flags, NB, PPB, NC, SLPP); 			    //setup reed solomon parameters
						CRiceDecompression riceDecomp((int)vcid[vc_id].flags,(int)vcid[vc_id].bits_per_pixel,(int)vcid[vc_id].pixels_per_block,(int)vcid[vc_id].num_columns,(int)vcid[vc_id].scan_lines_per_packet);
						if(riceDecomp.Decompress(vcid[vc_id].cp_pdu_data, (vcid[vc_id].len-1)))	//call the decompress function, return pass=1/fail=0, -3=-1 length definition -2 CRC
						{
//							fprintf(fp_debug,"           RICE OK\n");
						}
//						else
//						{
//							fprintf(fp_debug,"           RICE FAILED\n");
//						}
						fwrite(riceDecomp.Ptr(), riceDecomp.Size(), 1, vcid[vc_id].fp);
					}
					else {								//saved uncompressed data - crc
						fwrite(&vcid[vc_id].cp_pdu_data[0], (vcid[vc_id].len-1), 1, vcid[vc_id].fp);
					}
				}
				break;
			case 1:
				Decode_S_PDU();
				vcid[vc_id].fp=fopen(vcid[vc_id].filename,"wb");
				//save uncompressed data, skipping 10 byte Transport header at front and 2 byte crc at backend.
				fwrite(&vcid[vc_id].cp_pdu_data[10], (vcid[vc_id].len-1-10), 1, vcid[vc_id].fp);
				break;
			case 2:
				if (vcid[vc_id].filename[0] != '\0'){
					if (vcid[vc_id].compress == 1){		//decompression required
					//	CRiceDecompression riceDecomp(flags, NB, PPB, NC, SLPP); 			    //setup reed solomon parameters
						CRiceDecompression riceDecomp((int)vcid[vc_id].flags,(int)vcid[vc_id].bits_per_pixel,(int)vcid[vc_id].pixels_per_block,(int)vcid[vc_id].num_columns,(int)vcid[vc_id].scan_lines_per_packet);
						if(riceDecomp.Decompress(vcid[vc_id].cp_pdu_data, (vcid[vc_id].len-1)))	//call the decompress function, return pass=1/fail=0
						{
//							fprintf(fp_debug,"           RICE OK\n");
						}
//						else
//						{
//							fprintf(fp_debug,"           RICE FAILED\n");
//						}
						fwrite(riceDecomp.Ptr(), riceDecomp.Size(), 1, vcid[vc_id].fp);
					}
					else {								//saved uncompressed data - crc
						fwrite(&vcid[vc_id].cp_pdu_data[0], (vcid[vc_id].len-1), 1, vcid[vc_id].fp);
					}
					fclose(vcid[vc_id].fp);
					strcpy(vcid[vc_id].filename, "");
				}
				break;
			case 3:
				Decode_S_PDU();
				if (vcid[vc_id].filename[0] != '\0'){   //found that seq 3 may not have filename records, so don't open new file
					vcid[vc_id].fp=fopen(vcid[vc_id].filename,"wb");
					//save uncompressed data, skipping 10 byte Transport header at front and 2 byte crc at backend.
					fwrite(&vcid[vc_id].cp_pdu_data[10], (vcid[vc_id].len-1-10), 1, vcid[vc_id].fp);
					fclose(vcid[vc_id].fp);
					strcpy(vcid[vc_id].filename, "");
				}
				break;
			default:
				break;
		}
	}
	vcid[vc_id].cp_pdu_phdr = 0;
	vcid[vc_id].cp_pdu_pdata = 0;
	return;
}

int main(int argc, char* argv[])
{
	const BlockSize = 1024;
	DWORD BytesRead;

	Initialize();
	OpenUSB();
	Sync(1);

	while (TRUE) {
		while(TRUE) {
			if(kbhit()) {
				FT_Close(ftHandle);
//				fclose(fp_debug);
//				fclose(fp_test);
				for(int x=0; x<63; x++){
					if(vcid[x].filename[0] != '\0') {
						fseek(vcid[x].fp, 0, SEEK_SET);
						fclose(vcid[x].fp);
					}
				}
				return 0;
			}
			ftStatus = FT_GetQueueStatus(ftHandle, &BytesRecQueue);
			if (BytesRecQueue>BlockSize) {
				ftStatus = FT_Read(ftHandle, &frame, BlockSize, &BytesRead);
				break;
			}
		}
//		fwrite(&frame, 1024, 1, fp_data);
        Decode_VCDU();
		if (vc_id != 63) {
			Decode_MPDU();
			if ((mpdu_index == first_hdr_ptr) && (vcid[vc_id].cp_pdu_phdr)) {	//if first hdr ptr = 0
					Process_CP_PDU();				//process previous M_PDU data
			}
			for(mpdu_index=0 ; mpdu_index<884; mpdu_index++){
				if ((mpdu_index < first_hdr_ptr) && (!vcid[vc_id].cp_pdu_phdr)){
					mpdu_index = first_hdr_ptr;		//if not saving CP_PDU, skip to 1st hdr ptr
				}
				if (vcid[vc_id].cp_pdu_phdr < 6) {	//still filling CP_PDU Header Array
					vcid[vc_id].cp_pdu_hdr[vcid[vc_id].cp_pdu_phdr++] = frame.mpdu_data[mpdu_index];
					if (vcid[vc_id].cp_pdu_phdr == 6){
						Decode_CP_PDU();
					}					
				}
				else {								//else fill CP_PDU Data Array
					vcid[vc_id].cp_pdu_data[vcid[vc_id].cp_pdu_pdata++] = frame.mpdu_data[mpdu_index];
					if(vcid[vc_id].cp_pdu_pdata == (vcid[vc_id].len+1)){
						Process_CP_PDU();
					}
				}
				if (((mpdu_index + 1) == first_hdr_ptr) && vcid[vc_id].cp_pdu_phdr) {
					Process_CP_PDU();				//process new M_PDU data up to 1st hdr ptr
				}
			}while (mpdu_index < 884);
		}
	}
	return 0;
}
